/*

Covert channel using Algorithm 2 under Hyper-threaded sharing

Usage: see README (step 3.1) in the top level 
Authors: Wenjie Xiong (wenjie.xiong@yale.edu) and Jakub Szefer (jakub.szefer@yale.edu)

*/

#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/syscall.h>
#include <immintrin.h>
#include <x86intrin.h>
#include <pthread.h>
#include <assert.h>
#include <time.h>
#define gettid() syscall(SYS_gettid)
#include <dlfcn.h>
const int line_size=64;
const int way_size=64*64/8;
int g_stride=8;// next set

//this code uses set 48 to transfer info

char* chain_array[512*8]; // array to hold the pointer chasing chain  =way_size *8
unsigned int g_result[512*2*256];// to hold 100000 element, only use set 0-31 ((i/512)*1024+i%512)
char* probe[64*24*8];//64sets * 8 way * linesize
int perm[32]; 

int Tone=20000;
int Tzero=20000;
int Tmonitor=1000;

int para_d=4;
char sender_mode='a';
struct readThreadParams {                                                   
 char **start;
 char *chain; 
};   

void create_permutation(int size){
//  create random permutation of probe size in perm[]
	for(int i=0; i < size; i++){
		perm[i]=i;
	}

	for(int i=0; i < size; i++){
		int j = i + (rand()%(size-i));
		if(i!=j){
			int tmp=perm[i];
			perm[i]=perm[j];
			perm[j]=tmp;
		}
	
	}

	for(int i=0; i < size; i++){
		printf("% 8d", perm[i]);
	}
	printf("\n");

}


char* create_chain(int stride, int offset, char* last){
//create pointer chasing chain in probe array with stride
// offset decides which set to start
	char** start = &chain_array[perm[0]*stride + offset];
    
	for(int i=0; i < 6; i++){
		chain_array[perm[i]*stride + offset]= (char*) (& chain_array[perm[i+1]*stride + offset]);
        printf("%p\t",&chain_array[perm[i+1]*stride + offset]);
	}
	chain_array[perm[6]*stride + offset] = last;
    
    printf("\n");
    void* temp=start, *temp2;
    for(int i=0; i < 8; i++){
        temp2 = (void*) *(void**)temp;
        printf("%llx, %llx\n",temp, temp2);
        temp=temp2;
    }
    printf("\n");
	return start;
}

//receiver
void * test_delay(void* arg) {
  struct readThreadParams * arg_in=(struct readThreadParams *)arg;
  long long** start= arg_in->start;
  long long* chain= arg_in->chain;

  //printf("start thread! %d %p %p\n", victim, start[0], start[9]);
  for (int i=0;i<16;i++){
      long long tmp=*start[i];
      printf("address: %d %p 0x%llx 0x%llx\n", i, start[i], tmp, *(start[i]+256));
  }
  
  printf("result array\n");
  for (int i=0;i<512;i+=16){
      printf("0x%llx \t", &g_result[i]);
  }
  printf("\n");
  unsigned int No_test=100000;
  unsigned long long t=0;
  unsigned long long T_monitor_next=0;
    asm __volatile__ (
   "rdtsc               \n"
   : "=a" (t));
  T_monitor_next=t+ (unsigned long long)Tmonitor;
  int cnt=0;
  for (cnt=0;cnt<No_test;cnt++) 
  {

     for(int i=0;i<para_d;i++){
       asm __volatile__ (
       "movq (%%rcx),  %%rax     \n"
       "lfence              \n"
       "rdtsc               \n"
       : "=a" (t)
       : "c" (start[i]));
     }
    
      
    //Tmonitor
      if(T_monitor_next>0xFFFFFFFF){// T_moniter_next overflow
        do{
           asm __volatile__ (
           "movq (%%rcx), %%rax \n"
           "rdtsc               \n"
           : "=a" (t): "c"(chain));
        }while(t&0x80000000);
        T_monitor_next -= 0x100000000;
      }
      do{
       asm __volatile__ (
       "movq (%%rcx), %%rax \n"
       "rdtsc               \n"
       : "=a" (t): "c"(chain));
      } while(t < T_monitor_next && !(T_monitor_next&0x80000000  &&  !t&0x80000000));
      T_monitor_next += (unsigned long long)Tmonitor;
      

   //load another line into the same set to evict the LRU line
   for(int i=para_d;i<8;i++){
       asm __volatile__ (
           "movq (%%rcx),  %%rax     \n"
           "lfence              \n"
           "rdtsc               \n"
           : "=a" (t)
           : "c" (start[i]));
   }
  
     asm __volatile__ (
       "movq (%%rcx),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "lfence              \n"
       "rdtsc               \n"
       : "=a" (t)
       : "c" (chain));
  
     asm __volatile__ (
       "lfence              \n" 
       "rdtsc               \n"
       "movl %%eax, %%esi   \n"
       "movq (%%rcx),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "lfence              \n"
       "rdtsc               \n"
       "subl %%esi, %%eax   \n"
       : "=a" (t)
       : "c" (chain)
       : "%esi", "%edx");
      
    g_result[((cnt/512)*1024+cnt%512)]= t;
  }

  for (cnt=0;cnt<No_test;cnt++) 
  {
      printf("%d %d\n",cnt, g_result[((cnt/512)*1024+cnt%512)]);
  }
    
  return start;
}

void * sender(void* arg) {
  struct readThreadParams * arg_in=(struct readThreadParams *)arg;
  long long** start= arg_in->start;
  long long* chain= arg_in->chain;
  int message[128] = {0,0,0,0, 1,0,1,0, 1,1,1,1, 0,1,0,1};
   

  for (int i = 0;i < 10;i++){
      long long tmp = *start[i];
      printf("start thread! %d %p 0x%llx 0x%llx\n", i, start[i], tmp, *(start[i]+256));
  }

  if(sender_mode== '0'){
      for(int i =0; i< 128; i++){
            message[i] = 0;
      }
  }
  else if(sender_mode== '1'){
      for(int i =0; i< 128; i++){
            message[i] = 1;
      }
  }
  else if(sender_mode== 'r'){
        for(int i = 16;i < 128;i++){
        message[i]= rand()%2;
      } //generate random message
  }else{ // mode == 'a'
        for(int i =0; i< 128; i++){
            message[i] = i%2;
        } 
  }
    
  printf("Message to be sent: ");
  for(int i = 0;i < 128;i++){
    printf("%d",message[i]);
  }
  printf("\n");
    
  unsigned long long t=0;
  unsigned long long T_next=0;

  for (;;) 
  {
      for(int i=0;i<128;i++){
         if(message[i]==1){
             T_next+=(unsigned long long)Tone;
             //send one for Tone      
             if(T_next>0xFFFFFFFF){// T_moniter_next overflow
                do{
                    asm __volatile__ (
                   "movq (%%rcx),  %%rax     \n"
                   "rdtsc               \n"
                   : "=a" (t)
                   : "c" (start[8]));
                }while(t& 0x80000000);
                T_next -= 0x100000000;
              }
              do{
                asm __volatile__ (
               "movq (%%rcx),  %%rax     \n"
               "rdtsc               \n"
               : "=a" (t)
               : "c" (start[8]));
              }
              while(t < T_next  && !(T_next&0x80000000  &&  !t&0x80000000));
         }
       //send zero for Tzero
         else{
             T_next+=(unsigned long long)Tzero;
             if(T_next>0xFFFFFFFF){// T_moniter_next overflow
                do{
                    asm __volatile__ (
                   "movq (%%rcx),  %%rax     \n"
                   "rdtsc               \n"
                   : "=a" (t)
                   : "c" (start[0]));
                }while(t& 0x80000000);
                T_next -= 0x100000000;
              }
              do{
                asm __volatile__ (
               "movq (%%rcx),  %%rax     \n"
               "rdtsc               \n"
               : "=a" (t)
               : "c" (start[0]));
              }
              while(t < T_next  && !(T_next&0x80000000  &&  !t&0x80000000));
         }
       }
  }
  return start;
}

int main(int argc, char *argv[]) {
    
  int Is_sender=0;
  if(argc <2) { printf("wrong configure! must choose between sender or receiver\n"); return -1;}
  if (strcmp(argv[1], "sender") == 0){
      Is_sender=1;
      if(argc <3) { printf("wrong configure! must choose sender mode, opetions: \n 0 (send 0),\n 1 (send 1),\n a (send 010101...),\n r (send random bits after a prefix).\n"); return -1;}
      sender_mode=argv[2][0]; 
      if(argc >= 4){
        Tone=strtol(argv[3], NULL, 10);
        Tzero=strtol(argv[3], NULL, 10);
        printf("Tone=%d Tzero=%d\n",Tone,Tzero);
      }    
  }
  else if (strcmp(argv[1], "receiver") == 0){
      Is_sender=0;
     
      if(argc >= 3){
        Tmonitor=strtol(argv[2], NULL, 10);
        printf("Tmonitor=%d\n",Tmonitor);
      }  
      if(argc >= 4){
          para_d=strtol(argv[3], NULL, 10);
          printf("parameter d=%d\n",para_d);
      }
  } 
  else{ printf("wrong configure!\n"); return -1;}

  srand(1234);

  for(int i=0;i<8;i++) perm[i]=i;
  create_permutation(8);
  
  for(int i=0;i<64*24*8;i++){
    probe[i]=i;
  }   


  char *way[16];
  //for receiver  //set 48
  for(int i=0;i< 8;i++){// 8 way cache
    way[i]= &probe[perm[i]*way_size + (way_size/2) * (1-Is_sender)+(way_size/4)];
  }
  for(int i=8;i< 16;i++){
      way[i]=&probe[(i)*way_size + (way_size/2) * (1-Is_sender)+(way_size/4)];
  }
  //for sender  //set 48
  if(Is_sender){
      way[8]=&probe[17*way_size + (way_size/2) * (Is_sender)+(way_size/4)]; // in receiver's set
  }

  for(int i=0;i< 10;i++){
    printf("%p\t",way[i]);
  }
  printf("\n");

  char * chain;
  chain = create_chain(way_size, (way_size/2) * (1-Is_sender)+(way_size/4) +8, way[0]); //set 49
  printf("Pointer array created\n");
  
  cpu_set_t victim_set;
  CPU_ZERO(&victim_set); 
  cpu_set_t attacker_set;
  CPU_ZERO(&attacker_set);
    
  //For example, cpu 2 and 10 are sharing one core  
  CPU_SET(2,&victim_set);
  CPU_SET(10,&attacker_set);
  
    
  struct readThreadParams *attack_argv;
    
  attack_argv = (struct readThreadParams *)(malloc(sizeof(*attack_argv)));
  attack_argv -> start= &way;
  attack_argv -> chain= chain;
  
  printf("Parameters set\n");
  
   
  if(Is_sender){
    if(sched_setaffinity(gettid(),sizeof(cpu_set_t),&victim_set)==-1){
        printf("Can not set affinity\n");
        return 1;
    } 
    sender(attack_argv);
  }
  else{
     if(sched_setaffinity(gettid(),sizeof(cpu_set_t),&attacker_set)==-1){
        printf("Can not set affinity\n");
        return 1;
    }
    test_delay(attack_argv);
  }

  return 0;
}
