/*

Covert channel using Algorithm 1 under Time-Sliced sharing

Usage: see README (step 2.2) in the top level 
Authors: Wenjie Xiong (wenjie.xiong@yale.edu) and Jakub Szefer (jakub.szefer@yale.edu)

*/
#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/syscall.h>
#include <immintrin.h>
#include <x86intrin.h>
#include <pthread.h>
#include <assert.h>
#include <time.h>
#define gettid() syscall(SYS_gettid)
#include <dlfcn.h>
const int line_size=64;
const int way_size=64*64/8;
int g_stride=8;// next set

//this code uses set 48 to transfer info

char* chain_array[512*8]; // array to hold the pointer chasing chain  =way_size *8
unsigned int g_result[512*2*256];// to hold 100000 elements, only use set 0-31 ((i/512)*1024+i%512)
char** probe=NULL;
int perm[32]; 
char* error;
void *gadget_module = NULL;

int message=0;
int thr=43;

int Tmonitor=100000000;

int para_d=8;
struct readThreadParams {                                                   
 char **start;
 char *chain; 
};   

void create_permutation(int size){
//  create random permutation of probe size in perm[]
	for(int i=0; i < size; i++){
		perm[i]=i;
	}

	for(int i=0; i < size; i++){
		int j = i + (rand()%(size-i));
		if(i!=j){
			int tmp=perm[i];
			perm[i]=perm[j];
			perm[j]=tmp;
		}
	}

	for(int i=0; i < size; i++){
		printf("% 8d", perm[i]);
	}
	printf("\n");

}


char* create_chain(int stride, int offset, char* last){
//create pointer chasing chain in probe array with stride
// offset decides which set to start
	char** start = &chain_array[perm[0]*stride + offset];
    
	for(int i=0; i < 6; i++){
		chain_array[perm[i]*stride + offset]= (char*) (& chain_array[perm[i+1]*stride + offset]);
        printf("%p\t",&chain_array[perm[i+1]*stride + offset]);
	}
	chain_array[perm[6]*stride + offset] = last;
    
    printf("\n");
    void* temp=start, *temp2;
    for(int i=0; i < 8; i++){
        temp2 = (void*) *(void**)temp;
        printf("%llx, %llx\n",temp, temp2);
        temp=temp2;
    }
    printf("\n");
	return start;
}

//receiver
void * test_delay(void* arg) {
  struct readThreadParams * arg_in=(struct readThreadParams *)arg;
  long long** start= arg_in->start;
  long long* chain= arg_in->chain;

  for (int i=0;i<10;i++){
      long long tmp=*start[i];
      printf("address: %d %p 0x%llx 0x%llx\n", i, start[i], tmp, *(start[i]+256));
  }
  
  printf("result array\n");
  for (int i=0;i<512;i+=16){
      printf("0x%llx \t", &g_result[i]);
  }
  printf("\n");
  unsigned int No_test=1000;
  unsigned long long t=0;
  unsigned long long T_monitor_next=0;// T_monitor_real=0, measure_last=0; 
    asm __volatile__ (
   "rdtsc               \n"
   : "=a" (t));
  T_monitor_next=t+ (unsigned long long)Tmonitor;
  int cnt=0;
  for (cnt=0;cnt<No_test;cnt++) 
  {

     for(int i=0;i<para_d;i++){
       asm __volatile__ (
       "movq (%%rcx),  %%rax     \n"
       "lfence              \n"
       "rdtsc               \n"
       : "=a" (t)
       : "c" (start[i]));
     }
      
    //Tmonitor
      if(T_monitor_next>0xFFFFFFFF){// T_moniter_next overflow
        do{
           asm __volatile__ (
           "movq (%%rcx), %%rax \n"
           "rdtsc               \n"
           : "=a" (t): "c"(chain));
        }while(t&0x80000000);
        T_monitor_next -= 0x100000000;
      }
      do{
       asm __volatile__ (
       "movq (%%rcx), %%rax \n"
       "rdtsc               \n"
       : "=a" (t): "c"(chain));
      } while(t < T_monitor_next && !(T_monitor_next&0x80000000  &&  !t&0x80000000));
      T_monitor_next += (unsigned long long)Tmonitor;
      

   //load another line into the same set to evict the LRU line
   for(int i=para_d;i<9;i++){
       asm __volatile__ (
           "movq (%%rcx),  %%rax     \n"
           "lfence              \n"
           "rdtsc               \n"
           : "=a" (t)
           : "c" (start[i]));
   }
  
     asm __volatile__ (
       "movq (%%rcx),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "lfence              \n"
       "rdtsc               \n"
       : "=a" (t)
       : "c" (chain));
  
     asm __volatile__ (
       "lfence              \n" 
       "rdtsc               \n"
       "movl %%eax, %%esi   \n"
       "movq (%%rcx),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "movq (%%rax),  %%rax     \n"
       "lfence              \n"
       "rdtsc               \n"
       "subl %%esi, %%eax   \n"
       : "=a" (t)
       : "c" (chain)
       : "%esi", "%edx");
      
    g_result[((cnt/512)*1024+cnt%512)]= t;
  }

  int Zero_cnt=0, One_cnt=0;
  for (cnt=0;cnt<No_test;cnt++) 
  {
      printf("%d %d\n",cnt, g_result[((cnt/512)*1024+cnt%512)]);
      if(g_result[((cnt/512)*1024+cnt%512)] > 70) continue;
      if(g_result[((cnt/512)*1024+cnt%512)] > thr) Zero_cnt++;
      else One_cnt++;
  }
  printf("\nZero %d One %d\n",Zero_cnt, One_cnt);
  return start;
}

void * sender(void* arg) {
  struct readThreadParams * arg_in=(struct readThreadParams *)arg;
  long long** start= arg_in->start;
  long long* chain= arg_in->chain;

  for (int i = 0;i < 10;i++){
      long long tmp = *start[i];
      printf("start thread! %d %p 0x%llx 0x%llx\n", i, start[i], tmp, *(start[i]+256));
  }

  printf("Message to send: %d \n",message);
    
  unsigned long long t=0;
  unsigned long long T_next=0;

  for (;;) 
  {
         if(message==1){
                    asm __volatile__ (
                   "movq (%%rcx),  %%rax     \n"
                   : "=a" (t)
                   : "c" (start[9]));
         }
         else{
                    asm __volatile__ (
                   "movq (%%rcx),  %%rax     \n"
                   : "=a" (t)
                   : "c" (start[0]));
         }
       
  }
  return start;
}

int main(int argc, char *argv[]) {
    
  int Is_sender=0;
  if(argc <2) { printf("wrong configure! must choose between sender or receiver\n"); return -1;}
  if (strcmp(argv[1], "sender") == 0){
      Is_sender=1;
      if(argc >= 3){
          message=strtol(argv[2], NULL, 10);
      }
  }
  else if (strcmp(argv[1], "receiver") == 0){
      Is_sender=0;
     
      if(argc >= 3){
        Tmonitor=strtol(argv[2], NULL, 10);
        printf("Tmonitor=%d\n",Tmonitor);
      }  
      if(argc >= 4){
          para_d=strtol(argv[3], NULL, 10);
          printf("parameter d=%d\n",para_d);
      }
      if(argc >= 5){
          thr=strtol(argv[4], NULL, 10);
          printf("thr=%d\n",thr);
      }
  } 
  else{ printf("wrong configure!\n"); return -1;}

  srand(1234);

  for(int i=0;i<8;i++) perm[i]=i;
  create_permutation(8);

  gadget_module = dlopen("/usr/lib/x86_64-linux-gnu/liblruattack.so.1.0.1",  RTLD_LAZY);
  probe= (char**)(dlsym(gadget_module,"_binary_pi_txt_start"));
  error = dlerror();
    
  probe = probe + 1024*sizeof(void*);
    
    
  char *way[11];
  //for receiver  //set 48
  for(int i=0;i< 8;i++){// 8 way cache
    way[i]= &probe[perm[i]*way_size + (way_size/2) * (1-Is_sender)+(way_size/4)];
  }
  way[8]=&probe[10*way_size + (way_size/2) * (1-Is_sender)+(way_size/4)];
    
  //for sender  //set 48
  way[9]=&probe[perm[0]*way_size + (way_size/2) * (Is_sender)+(way_size/4)]; //= way[0] of receiver
    
  
  for(int i=0;i< 10;i++){
    printf("%p\t",way[i]);
  }
  printf("\n");

  char * chain;
  chain = create_chain(way_size, (way_size/2) * (1-Is_sender)+(way_size/4) +8, way[0]); //set 49
  printf("Pointer array created\n");
  
  cpu_set_t victim_set;
  CPU_ZERO(&victim_set); 
  CPU_SET(1,&victim_set);
  cpu_set_t attacker_set;
  CPU_ZERO(&attacker_set); 
  CPU_SET(1,&attacker_set);
    
  struct readThreadParams *attack_argv;
    
  attack_argv = (struct readThreadParams *)(malloc(sizeof(*attack_argv)));
  attack_argv -> start= &way;
  attack_argv -> chain= chain;
  
  printf("Parameters set\n");
  
   
  if(Is_sender){
    if(sched_setaffinity(gettid(),sizeof(cpu_set_t),&victim_set)==-1){
        printf("Can not set affinity\n");
        return 1;
    } 
    sender(attack_argv);
  }
  else{
     if(sched_setaffinity(gettid(),sizeof(cpu_set_t),&attacker_set)==-1){
        printf("Can not set affinity\n");
        return 1;
    }
    test_delay(attack_argv);
  }

  return 0;
}
